var express = require('express');
var cors = require('cors');
var fs = require('fs');
var https = require('https');
var socketIo = require('socket.io');

// SSL Certificates
var privateKey = fs.readFileSync('C:/Certbot/live/socket.quayphimsanbong.com/privkey.pem', 'utf8');
var certificate = fs.readFileSync('C:/Certbot/live/socket.quayphimsanbong.com/fullchain.pem', 'utf8');

var credentials = {
  key: privateKey,
  cert: certificate,
};

var app = express();
app.use(cors({
  origin: '*', // Allow all origins
}));
// Create HTTPS server
var server = https.createServer(credentials, app);

// Attach Socket.IO to the server
var io = socketIo(server);

// Port settings
var port = (process.env.OPENSHIFT_NODEJS_PORT || process.env.PORT || 6969);
server.listen(port, () => console.log('Secure server running on port ' + port));

// Socket.IO event handling
io.on('connection', function (socket) {
  socket.on('all client', function (data) {
    io.sockets.emit('news', data); // Send to all clients
  });

  socket.on('broadcast', function (data) {
    socket.broadcast.emit('news', data); // Broadcast to all clients except the sender
  });

  socket.on('private', function (data) {
    socket.emit('news', data); // Send to the current client
  });
});

// Serve your HTML file
app.get('/', cors(), (req, res) => {
  res.sendFile('test-socket-client.html', { "root": __dirname });
});
